class Cesta {
    constructor(data, texturaSemaforu, texturyZnacek, texturyCesty, xOffset, yOffset) {
        this.data = data;
        this.texturaSemaforu = texturaSemaforu;
        this.texturyZnacek = texturyZnacek;
        this.texturyCesty = texturyCesty;
        this.xOff = xOffset || 0;
        this.yOff = yOffset || 0;
        this.sitPruhu = [];
        this.znacky = [];
        this.semafory = [];
        this.hitboxyKrizovatky = [];
        this.zobrazovatPruhy = false;
        this.vytvoritCestu();

        this.spawny = [];
        this.selectedSpawn;
        this.slidery = [];
        this.subButtony = [];
        this.frekvenceValue;
        this.najitTrasy();
    }

    najitTrasy() {
        this.zalozSpawny();
        this.spawny.forEach(spawn => {
            const i = spawn.indexPruhu;
            this.sitPruhu[i].najitCile(spawn.cile);
            spawn.trasy = Pruh.najitTrasy(spawn.cile);
            for (let j in spawn.trasy) {
                spawn.spawnRateTras[j] = 3;
            }
            this.sitPruhu.forEach(pruh => pruh.visited = 0);
        });
    }


    vytvoritCestu() {
        this.data.sitPruhu.forEach(p => {
            this.sitPruhu = [...this.sitPruhu, new Pruh(p.startx + this.xOff, p.starty + this.yOff, p.sizex, p.sizey, p.hlavni)];
        });

        if (this.data.semafory) {
            this.data.semafory.forEach(s => {
                if (s.texturaX) {
                    this.semafory = [...this.semafory, new Semafor(s.posx + this.xOff, s.posy + this.yOff, s.state, s.cervenaDuration, s.zelenaDuration, s.startingTime, this.texturaSemaforu, s.texturaX, s.texturaY, s.texturaAngle)];
                } else {
                    this.semafory = [...this.semafory, new Semafor(s.posx + this.xOff, s.posy + this.yOff, s.state, s.cervenaDuration, s.zelenaDuration, s.startingTime)];
                }
            });
        }

        if (this.data.znacky) {
            this.data.znacky.forEach(znacka => {
                let textura = this.vyberTexturuZnacky(znacka.typ);
                this.znacky = [...this.znacky, new Znacka(znacka.typ, textura, znacka.posx + this.xOff, znacka.posy + this.yOff, znacka.angle)];
            });
        }

        if (this.data.hitboxyKrizovatky) {
            this.data.hitboxyKrizovatky.forEach(h => {
                this.hitboxyKrizovatky = [...this.hitboxyKrizovatky, new HitboxKrizovatky(h.x1 + this.xOff, h.y1 + this.yOff, h.x2 + this.xOff, h.y2 + this.yOff, h.x3 + this.xOff, h.y3 + this.yOff, h.x4 + this.xOff, h.y4 + this.yOff, h.zacatek)];
            });
        }

        this.sitPruhu.forEach(pruh => {
            pruh.getNextPruh(this.sitPruhu);
        });

        this.sitPruhu.forEach(p => p.setriditPrev());
        for (let i = 0; i < this.sitPruhu.length; i++) {
            let p1 = this.sitPruhu[i];
            for (let j = 0; j < this.sitPruhu.length; j++) {
                if (i !== j) {
                    let p2 = this.sitPruhu[j];
                    p1.kriziSe(p2);
                }
            }
        }
    }

    zalozSpawny() {
        for (let i = 0; i < this.sitPruhu.length; i++) {
            if (this.sitPruhu[i].previousPruhy.length == 0) {
                this.spawny = [...this.spawny, new Spawn(i, this.sitPruhu[i].start, this.sitPruhu[i].dir)];
            }
        }
    }

    vyberTexturuZnacky(typ) {
        return this.texturyZnacek[typ];
    }

    vyberTexturuCesty() {
        if (this.data.textura !== undefined) {
            return this.texturyCesty[this.data.textura];
        } else {
            this.zobrazovatPruhy = true;
            return 140;
        }
    }


    ulozitJSON() {
        let pomocnaSitPruhu = [];

        this.sitPruhu.forEach(p => {
            pomocnaSitPruhu = [...pomocnaSitPruhu, {startx: p.start.x, starty: p.start.y, sizex: p.size.x, sizey: p.size.y, hlavni: p.hlavni}];
        });

        let pomocneZnacky = [];
        this.znacky.forEach(z => { 
            pomocneZnacky = [...pomocneZnacky, {typ: z.typ, posx: z.pos.x, posy: z.pos.y, angle: z.angle}];
        })

        var json = {
            nazev: this.data.nazev,
            sitPruhu: pomocnaSitPruhu,
            class: this.data.class,
            textura: this.data.textura,
            hitboxyKrizovatky: this.hitboxyKrizovatky,
            znacky: pomocneZnacky
        };
        saveJSON(json, 'mapa');
    }
}
