class Doprava {
    constructor(cesta, texturyAut, trashicon) {
        this.auta = [];
        this.autaVKrizovatce = [];
        this.texturyAut = texturyAut;
        this.cesta = cesta;
        this.pridatAuta();
        this.startTime = performance.now();
        this.delkaPauzy = 0;
        this.stoppedTime;
        this.elapsedTime = 0;
        this.spawnnoutAuto = true;
        this.perioda;
        this.pohyb = true;

        this.bezpecnaVzdalenostProSpawn = 100;
        this.soucasnaTextura = this.texturyAut[floor(random(this.texturyAut.length))];

        this.stavSemaforu = [];
        this.casySemaforu = [];
        this.pozastavitProvoz();
        this.limitAut = 10;

        this.delkaUpozorneni = 0;
        this.docasneAuto = null;
        this.docasnaTrasa = null;

        this.autoKUpraveni = null;
        this.trashicon = trashicon;
        this.muzeOdstranitAuto = false;
        this.typUpozorneni; // 0 - max limit, 1 - auta jsou v krizovatce
    }
    vybratSpawn() {
        let spawny = [];
        for (let i in this.cesta.spawny) {
            const aktualni = this.cesta.spawny[i];
            for (let j = 0; j < aktualni.frekvence; j++) {
                spawny = [...spawny, aktualni];
            }
        }
        let index = floor(random(0, spawny.length));
        return spawny[index];
    }

    fungovani() {
        let res = [];

        for (let k = this.auta.length - 1; k >= 0; k--) {
            if (this.auta[k].maseznicit) {
                this.auta.splice(k, 1);
            }
        }

        if (this.pohyb) {
            this.cesta.spawny.forEach(spawn => {
                if (spawn.autaKPridani.length > 0) {
                    if (!this.jeObsazenySpawn(spawn) && !this.autaVKrizovatce.length) {
                        this.auta = [...this.auta, spawn.autaKPridani[0]];
                        spawn.autaKPridani.splice(0, 1);

                    }
                }
            });

            this.elapsedTime = floor((performance.now() - this.startTime - this.delkaPauzy) / 100);

            for (let i in this.auta) {
                this.auta[i].ostatniAuta = [];
                for (let j in this.auta) {
                    if (i !== j)
                        this.auta[i].ostatniAuta = [...this.auta[i].ostatniAuta, this.auta[j]];
                }
            }

            this.autaVKrizovatce = this.auta.filter(auto => auto.jeVKrizovatce);

            res = this.jeZacyklena();
            if (res.length > 0) {
                this.auta[res[0]].musiProjetKrizovatkou = true;
            }
        }

        this.volbaAuta();

        for (let i = 0; i < this.auta.length; i++) {
            this.auta[i].show();
            if (this.pohyb) {
                this.auta[i].move();
            }
        }

        if (this.cesta.zobrazovatPruhy) {
            this.cesta.sitPruhu.forEach(pruh => pruh.show());
        } else {
            this.cesta.sitPruhu.forEach(pruh => pruh.show2());
        }

        this.cesta.semafory.forEach(semafor => semafor.show());
        this.cesta.znacky.forEach(znacka => znacka.show());
        this.cesta.spawny.forEach(spawn => spawn.show());
        this.zobrazovatUpozorneni();
    }

    volbaAuta() {
        if (this.docasneAuto !== null) {
            const currSpawn = this.cesta.spawny[this.docasneAuto];
            currSpawn.ukazatAutoKPridani(this.soucasnaTextura.arr[0]);
            this.zvyraznitDocasneTrasy(currSpawn);
        } else if (this.autoKUpraveni !== null) {
            const currSpawn = this.autoKUpraveni.spawn;
            let auto = doprava.jeObsazenySpawn(this.autoKUpraveni.spawn);
            if (auto === this.autoKUpraveni) {
                this.zvyraznitDocasneTrasy(currSpawn);
            } else {
                this.oddelatZvyrazneni();
            }
        }
    }

    oddelatZvyrazneni() {
        doprava.docasneAuto = null;
        doprava.autoKUpraveni = null;
        doprava.docasnaTrasa = null;
        doprava.cesta.sitPruhu.forEach(pruh => pruh.maSeZvyraznit = 0);
    }

    zvyraznitDocasneTrasy(currSpawn) {
        for (let i = 0; i < currSpawn.trasy.length; i++) {
            currSpawn.zvyraznitTrasu(i, true);
        }

        this.docasnaTrasa = null;
        for (let i = 0; i < currSpawn.trasy.length; i++) {
            if (currSpawn.jeKurzorNaTrase(i)) {
                currSpawn.zvyraznitTrasu(i, 2);
                this.docasnaTrasa = i;
                cursor('pointer');
                break;
            }
        }

        if (this.docasnaTrasa === null) {
            cursor(ARROW)
        }

        push();
        let scl = 45;
        let d = 40;
        let cx = currSpawn.xpos + currSpawn.dir.x * scl - currSpawn.dir.y * scl;
        let cy = currSpawn.ypos + currSpawn.dir.y * scl + currSpawn.dir.x * scl;
        stroke(255);

        if (dist(mouseX, mouseY, cx, cy) <= d / 2) {
            this.muzeOdstranitAuto = true;
            cursor('pointer');
            fill(255, 0, 0);
        }
        else {
            this.muzeOdstranitAuto = false;
            fill(255);
        }


        imageMode(CENTER);

        circle(cx, cy, d);
        image(this.trashicon, cx, cy);
        pop();
    }

    pridejAuto(spawn, trasacislo) {
        let pocetAutKPridani = 0;
        this.cesta.spawny.forEach(spawn => {
            pocetAutKPridani += spawn.autaKPridani.length;
        });
        if (pocetAutKPridani < this.limitAut) {
            let trasa = cesta.spawny[spawn].trasy[trasacislo];

            if (!this.autaVKrizovatce.length && !this.jeObsazenySpawn(trasa)) {
                this.auta = [...this.auta, new Auto(this.cesta, trasa, this.soucasnaTextura, cesta.spawny[spawn])];
                this.zmenNextTexturu();
            } else {
                cesta.spawny[spawn].autaKPridani.push(new Auto(this.cesta, trasa, this.soucasnaTextura, cesta.spawny[spawn]));
                this.zmenNextTexturu();
            }
        } else {
            this.delkaUpozorneni = 100
            this.typUpozorneni = 0;
        }
    }

    pridejDocasneAuto(spawn) {
        this.docasneAuto = spawn;
    }

    zmenNextTexturu() {
        this.soucasnaTextura = this.texturyAut[floor(random(this.texturyAut.length))];
    }

    zobrazovatUpozorneni() {
        if (this.delkaUpozorneni > 0) {
            push()
            let pruhlednost = 255 * sin(this.delkaUpozorneni * HALF_PI / 100)
            fill(255, 0, 0, pruhlednost)
            stroke(0, pruhlednost)
            strokeWeight(2)
            rectMode(CORNERS)
            rect(10, height - 60, 290, height - 10, 5)
            noStroke()
            fill(255, pruhlednost)
            textSize(16)
            textAlign(CENTER)
            if (this.typUpozorneni) {
                text('Počkejte, prosím, až křižovatkou\nnebudou projíždět jiná vozidla.', 150, height - 40)
            }
            else {
                text(`Nelze přidat více než ${this.limitAut} aut najednou.\nPočkejte prosím, až se uvolní místo.`, 150, height - 40)
            }
            pop()
            this.delkaUpozorneni--
        }
    }

    jeObsazenySpawn(spawn) {
        let autoNaSpawnu = null;
        this.auta.forEach(auto => {
            if ((auto.pos.x - spawn.xpos) * (auto.pos.x - spawn.xpos) + (auto.pos.y - spawn.ypos) * (auto.pos.y - spawn.ypos) <= this.bezpecnaVzdalenostProSpawn * this.bezpecnaVzdalenostProSpawn) {
                autoNaSpawnu = auto;
            }
        })
        return autoNaSpawnu;
    }

    pridatAuta() {
        for (let i in this.auta) {
            for (let j in this.auta) {
                if (i !== j) {
                    this.auta[i].ostatniAuta = [...this.auta[i].ostatniAuta, this.auta[j]];
                }
            }
        }
    }

    pozastavitProvoz() {
        if (this.pohyb == true) {
            this.pohyb = false;
            this.stoppedTime = performance.now();

            this.stavSemaforu = [];
            this.casySemaforu = [];

            this.cesta.semafory.forEach(semafor => {
                semafor.zastavit();

                this.stavSemaforu = [...this.stavSemaforu, semafor.state];
                this.casySemaforu = [...this.casySemaforu, performance.now() - semafor.casZastaveni + semafor.startingTime];
            });
        }
    }

    spustitProvoz() {
        if (this.pohyb == false) {
            this.delkaPauzy += performance.now() - this.stoppedTime;
            this.pohyb = true;

            if (this.stavSemaforu.length > 0) {
                const len = this.cesta.semafory.length;
                for (let a = 0; a < len; a++) {
                    let s = this.cesta.semafory[a];

                    if (s.texturaX) {
                        this.cesta.semafory[a] = new Semafor(s.pos.x, s.pos.y, s.state, s.cervenaDuration, s.zelenaDuration, this.casySemaforu[a], this.cesta.texturaSemaforu, s.texturaX, s.texturaY, s.texturaAngle);
                    } else {
                        this.cesta.semafory[a] = this.cesta.semafory, new Semafor(s.pos.x, s.pos.y, s.state, s.cervenaDuration, s.zelenaDuration, this.casySemaforu[a]);
                    }
                }
            }
        }
    }

    jeZacyklena() {
        let k = 0;
        let arr = [];
        while (k < this.auta.length) {
            this.auta.forEach(auto => auto.visited = false);
            if (this.auta[k].jeZacyklene()) {
                arr = [...arr, k];
            }
            k++;
        }
        return arr;
    }
}