let cesta;
let doprava;
let kurzor;
let prvky;
let typ;
let prevTyp;
let cestyJSON = [];
let vyber = document.querySelectorAll("#krizovatka option");
const select = document.querySelector("#krizovatka");
let cestyPozadi = [];
let texturyAut = [];
let texturaSemaforu;
let texturyZnacek = [];
let bg;
let trashicon;

function preload() {
    let pathMapy = 'nahranecesty/ymapa-';
    for (let i = 0; i < vyber.length; i++) {
        let name = pathMapy + i.toString() + ".json";
        let data = loadJSON(name, () => {
            cestyJSON[i] = data;
            vyber[i].innerHTML = data.nazev;
        }, (err) => {
            window.alert("nepodarilo se nacist soubory");
            console.alert(err);
        });
    }

    let pathCesty = 'grafika/cesty/cesta-';
    for (let i = 0; i < 2; i++) {
        let name = pathCesty + i.toString() + ".png";
        let img = loadImage(name, () => {
            cestyPozadi[i] = img;
        });
    }

    for (let i = 0; i < 18; i++) {
        nacistAuta(i).then(arr => {
            texturyAut = [...texturyAut, new Textura(arr)];
        });
    }

    nacistSemafor().then(tSemaforu => texturaSemaforu = new Textura(tSemaforu)).catch(err => console.error("nepodarilo se nacist semafor", err));
    nacistZnacky().then(znacky => texturyZnacek = [...znacky]).catch(err => console.error("nepodarilo se nacist znacky", err));

    loadImage("grafika/trash-icon.png", img => {
        img.resize(30, 0);
        trashicon = img;
    });
}

function setup() {
    var cnv = createCanvas(800, 600);
    cnv.parent('misto-pro-canvas');

    canvas.onselectstart = function () { return false; }

    frameRate(30);
    typ = select.value;

    rerunSetup();
}

function draw() {
    background(255, 0);
    background(bg);

    // console.log(mouseX, mouseY);
    typ = select.value;
    if (prevTyp === typ) {
        prvky.updatePrvky();
        doprava.fungovani();
        kurzor.fungovani();
    } else {
        rerunSetup();
    }



}

function rerunSetup() {
    cesta = new Cesta(cestyJSON[parseInt(typ)], texturaSemaforu, texturyZnacek, cestyPozadi);
    doprava = new Doprava(cesta, texturyAut, trashicon);
    kurzor = new Kurzor(doprava);
    prvky = new Prvky(doprava);
    bg = cesta.vyberTexturuCesty();
    prevTyp = typ;
}

async function nacistAuta(i) {
    let arr = await Promise.all([
        loadImage(`grafika/auta/a-${i.toString()}.png`, img => img.resize(85, 0)),
        loadImage(`grafika/auta-pravyblinkr/a-${i.toString()}-p.png`, img => img.resize(85, 0)),
        loadImage(`grafika/auta-levyblinkr/a-${i.toString()}-l.png`, img => img.resize(85, 0)),
        loadImage(`grafika/auta-brzda/a-${i.toString()}-b.png`, img => img.resize(85, 0)),
        loadImage(`grafika/auta-pravysbrzdou/a-${i.toString()}-pb.png`, img => img.resize(85, 0)),
        loadImage(`grafika/auta-levysbrzdou/a-${i.toString()}-lb.png`, img => img.resize(85, 0))
    ]);

    return arr;
}

async function nacistSemafor() {
    let path = "grafika/znacky/semafor-";
    let semafor = await Promise.all([
        loadImage(path + "0.png", img => img.resize(100, 0)),
        loadImage(path + "1.png", img => img.resize(100, 0)),
        loadImage(path + "2.png", img => img.resize(100, 0)),
        loadImage(path + "3.png", img => img.resize(100, 0))
    ]);
    return semafor;
}

async function nacistZnacky() {
    let path = "grafika/znacky/";
    let znacky = await Promise.all([
        loadImage(path + "hlavni.png", img => img.resize(120, 0)), //0
        loadImage(path + "konec_hlavni.png", img => img.resize(100, 0)), //1
        loadImage(path + "krizovatka.png", img => img.resize(100, 0)), //2
        loadImage(path + "prednost.png", img => img.resize(100, 0)), //3
        loadImage(path + "stop.png", img => img.resize(100, 0)), //4
        loadImage(path + "hlavni-t-se.png", img => img.resize(45, 0)), //5
        loadImage(path + "hlavni-t-sw.png", img => img.resize(45, 0)), //6
        loadImage(path + "hlavni-t-we.png", img => img.resize(45, 0)), //7
        loadImage(path + "hlavni-x-ne.png", img => img.resize(45, 0)), //8
        loadImage(path + "hlavni-x-se.png", img => img.resize(45, 0)), //9
        loadImage(path + "hlavni-x-sn.png", img => img.resize(45, 0)), //10
        loadImage(path + "hlavni-x-sw.png", img => img.resize(45, 0)), //11
        loadImage(path + "hlavni-x-we.png", img => img.resize(45, 0)), //12
        loadImage(path + "hlavni-x-wn.png", img => img.resize(45, 0)), //13

        loadImage(path + "prednost-t-se.png", img => img.resize(45, 0)), //14
        loadImage(path + "prednost-t-sw.png", img => img.resize(45, 0)), //15
        loadImage(path + "prednost-t-we.png", img => img.resize(45, 0)), //16
        loadImage(path + "prednost-x-ne.png", img => img.resize(45, 0)), //17
        loadImage(path + "prednost-x-se.png", img => img.resize(45, 0)), //18
        loadImage(path + "prednost-x-sn.png", img => img.resize(45, 0)), //19
        loadImage(path + "prednost-x-sw.png", img => img.resize(45, 0)), //20
        loadImage(path + "prednost-x-we.png", img => img.resize(45, 0)), //21
        loadImage(path + "prednost-x-wn.png", img => img.resize(45, 0)), //22
        loadImage(path + "prednost-t-ne.png", img => img.resize(45, 0)), //23

        loadImage(path + "hlavni-t-sw2.png", img => img.resize(45, 0)), //24
        loadImage(path + "hlavni-t-se2.png", img => img.resize(45, 0)), //25
        loadImage(path + "prednost-t-wn2.png", img => img.resize(45, 0)), //26


    ]);
    return znacky;
}