class Doprava {
    constructor(cesta, texturyAut, texturyAutSPrednosti) {
        this.auta = [];
        this.texturyAut = texturyAut;
        this.texturyAutSPrednosti = texturyAutSPrednosti;
        this.nepouziteTextury = texturyAut;
        this.cesta = cesta;
        this.startTime = performance.now();
        this.delkaPauzy = 0;
        this.stoppedTime;
        this.elapsedTime = 0;
        this.spawnnoutAuto = true;
        this.perioda;
        this.pohyb = true;
        this.bylaPozastavena = false;
        this.konecAnimace = false;
        this.odpoved;

        this.bezpecnaVzdalenostProSpawn = 120;
        this.soucasnaTextura = this.texturyAut[floor(random(this.texturyAut.length))];

        this.stavSemaforu = [];
        this.casySemaforu = [];
        this.vytvorSituaci();
    }
    vybratSpawn() {
        let spawny = [];
        for (let i in this.cesta.spawny) {
            const aktualni = this.cesta.spawny[i];
            for (let j = 0; j < aktualni.frekvence; j++) {
                spawny = [...spawny, aktualni];
            }
        }
        let index = floor(random(0, spawny.length));
        return spawny[index];
    }

    pozastavitAnimaci() {
        if (!this.bylaPozastavena && this.auta.filter(auto => auto.jeVKrizovatce).length) {
            this.bylaPozastavena = true;
            this.pozastavitProvoz();
            this.auta.forEach(a => a.zobrazovatBrzdu = false);
            let button = document.querySelector('.potvrditodpoved input');
            button.className = 'btn';
        }
    }

    fungovani() {
        let res = -1;
        this.pozastavitAnimaci();

        if (this.pohyb) {
            this.cesta.spawny.forEach(spawn => {
                if (spawn.autaKPridani.length > 0) {
                    let trasa = spawn.autaKPridani[0].trasa;

                    if (!this.autaVKrizovatce.length && this.jeVolnySpawn(trasa)) {
                        this.auta = [...this.auta, spawn.autaKPridani[0]];
                        spawn.autaKPridani.splice(0, 1);

                    }
                }
            });

            this.elapsedTime = floor((performance.now() - this.startTime - this.delkaPauzy) / 100);
            res = this.jeZacyklena();
        }

        for (let k = this.auta.length - 1; k >= 0; k--) {
            if (this.auta[k].maseznicit)
                this.auta.splice(k, 1);
        }

        for (let i in this.auta) {
            this.auta[i].ostatniAuta = [];
            for (let j in this.auta) {
                if (i !== j)
                    this.auta[i].ostatniAuta = [...this.auta[i].ostatniAuta, this.auta[j]];
            }
        }

        if (this.cesta.zobrazovatPruhy) {
            this.cesta.sitPruhu.forEach(pruh => pruh.show());
        } else {
            this.cesta.sitPruhu.forEach(pruh => pruh.show2());
        }
        for (let i = 0; i < this.auta.length; i++) {
            this.auta[i].show();
            if (this.pohyb) {
                if (res === i) {
                    this.auta[i].move(true);
                } else {
                    this.auta[i].move();
                }
            }
        }
        this.cesta.semafory.forEach(semafor => semafor.show());
        this.cesta.znacky.forEach(znacka => znacka.show());
        this.cesta.spawny.forEach(spawn => spawn.show());
        // this.cesta.hitboxyKrizovatky.forEach(hb => hb.show());
        push();
        rectMode(CENTER);
        textAlign(CENTER);
        textSize(20);
        let scl = 35;
        for (let e = 0; e < this.auta.length; e++) {
            let a = this.auta[e];
            fill(255);
            noStroke();
            let xpos = a.pos.x + a.dir.x * scl - a.dir.y * scl * 1.2;
            let ypos = a.pos.y + a.dir.y * scl + a.dir.x * scl * 1.2;
            rect(xpos, ypos, 30, 30, 10);
            strokeWeight(1);
            stroke(0);
            fill(0);
            text(e + 1, xpos, ypos + 8);
        }
        pop();
        this.skoncilaAnimace();

    }

    skoncilaAnimace() {
        if (!this.auta.length) {
            this.konecAnimace = true;
            noLoop();
        }

    }

    vytvorSituaci() {
        let s = this.cesta.situace;
        s.auta.forEach(auto => {
            this.pridejAuto(auto.spawn, auto.trasa, auto.rychlost, auto.prednostnijizda);
        })

    }
    pridejAuto(spawn, trasacislo, rychlost, prednostnijizda) {

        let trasa = cesta.spawny[spawn].trasy[trasacislo];




        if (this.jeVolnySpawn(trasa)) {
            if (prednostnijizda) {
                this.auta = [...this.auta, new AutoSPrednosti(this.cesta, trasa, this.texturyAutSPrednosti[0], rychlost)];
            } else {
                this.auta = [...this.auta, new Auto(this.cesta, trasa, this.soucasnaTextura, rychlost)];
                this.zmenNextTexturu();
            }
        } else {
            if (prednostnijizda) {
                cesta.spawny[spawn].autaKPridani.push(new AutoSPrednosti(this.cesta, trasa, this.texturyAutSPrednosti[0], rychlost)
                );
            } else {
                cesta.spawny[spawn].autaKPridani.push(new Auto(this.cesta, trasa, this.soucasnaTextura, rychlost));
                this.zmenNextTexturu();
            }
        }
    }

    zmenNextTexturu() {
        this.nepouziteTextury = this.nepouziteTextury.filter(t => t !== this.soucasnaTextura);
        if (this.nepouziteTextury.length > 0) {
            this.soucasnaTextura = this.nepouziteTextury[floor(random(this.nepouziteTextury.length))];
        } else {
            this.soucasnaTextura = this.texturyAut[floor(random(this.texturyAut.length))];
        }
    }

    jeVolnySpawn(trasa) {
        let safe = true;
        this.auta.forEach(auto => {
            if (auto.trasa[0] === trasa[0]) {
                if ((auto.pos.x - trasa[0].start.x) * (auto.pos.x - trasa[0].start.x) + (auto.pos.y - trasa[0].start.y) * (auto.pos.y - trasa[0].start.y) < this.bezpecnaVzdalenostProSpawn * this.bezpecnaVzdalenostProSpawn) {
                    safe = false;
                }
            }
        })
        return safe;
    }

    pridatAuta() {
        for (let i in this.auta) {
            for (let j in this.auta) {
                if (i !== j) {
                    this.auta[i].ostatniAuta = [...this.auta[i].ostatniAuta, this.auta[j]];
                }
            }
        }

    }

    pozastavitProvoz() {
        if (this.pohyb == true) {
            this.pohyb = false;
            this.stoppedTime = performance.now();

            this.stavSemaforu = [];
            this.casySemaforu = [];

            this.cesta.semafory.forEach(semafor => {
                semafor.zastavit();

                this.stavSemaforu = [...this.stavSemaforu, semafor.state];
                this.casySemaforu = [...this.casySemaforu, performance.now() - semafor.casZastaveni + semafor.startingTime];
            });
        }
    }

    spustitProvoz() {
        if (this.pohyb == false) {
            this.auta.forEach(a => {
                a.zobrazovatBrzdu = true;
                if (a.davaBlinkrDriv) {
                    a.zataceni = 0;
                    a.davaBlinkrDriv = false;
                }
            });
            this.delkaPauzy += performance.now() - this.stoppedTime;
            this.pohyb = true;

            if (this.stavSemaforu.length > 0) {
                const len = this.cesta.semafory.length;
                for (let a = 0; a < len; a++) {
                    let s = this.cesta.semafory[a];

                    if (s.texturaX) {
                        this.cesta.semafory[a] = new Semafor(s.pos.x, s.pos.y, s.state, s.cervenaDuration, s.zelenaDuration, s.startingTime, this.cesta.texturaSemaforu, s.texturaX, s.texturaY, s.texturaAngle);
                    } else {
                        this.cesta.semafory[a] = this.cesta.semafory, new Semafor(s.pos.x, s.pos.y, s.state, s.cervenaDuration, s.zelenaDuration, s.startingTime);
                    }
                }
            }
        }
    }

    vybratOdpoved() {
        if (this.bylaPozastavena && !this.pohyb) {
            let radios = document.querySelectorAll('.moznosti input[type=radio]');
            let vybrano;
            radios.forEach(radio => {
                if (radio.checked) {
                    this.odpoved = radio.value;
                    vybrano = true;
                }
            });

            if (vybrano) {
                let button = document.querySelector('.potvrditodpoved button');
                button.innerHTML = "přeskočit animaci";
                this.spustitProvoz();
            } else {
            }
        } else if (this.bylaPozastavena) {
            // console.log(this.odpoved);
            window.alert("aniamce se preskoci a pujde se na novou situaci");
        }
    }

    jeZacyklena() {
        let i = 0;
        while (i < this.auta.length) {
            this.auta.forEach(auto => auto.visited = false);
            if (this.auta[i].jeZacyklene()) {
                return i;
            }
            i++;
        }
        return false;
    }
}