class Prvky {
    constructor(doprava) {
        this.d = doprava;
        this.c = this.d.cesta;
        this.vytvoritPrvky();

        this.uplynulyCas = document.querySelector(".frameCount");

    }

    vytvoritPrvky() {
        const predchoziSlider = document.querySelector("#spawnRate input");
        if (predchoziSlider) {
            predchoziSlider.remove();
        }
        this.vycistitPredchoziBoksi("#subkonfigurace > div");

        this.vytvorBoksi();

    }

    updatePrvky() {


        this.uplynulyCas.innerHTML = (this.d.elapsedTime / 10).toFixed(1);

    }

    vycistitPredchoziBoksi(selector) {
        const predchoziBoksi = document.querySelectorAll(selector);
        predchoziBoksi.forEach(box => {
            box.remove();
        })
    }

    vytvorBoksi() {
        this.vycistitPredchoziBoksi("#konfigurace > div");
        for (let xd = 0; xd < this.c.spawny.length; xd++) {
            const akce = document.createElement("div");
            akce.id = "slider" + xd.toString();
            document.querySelector("#konfigurace").appendChild(akce);

            const p = document.createElement("p");
            p.innerHTML = "Spawn " + (xd + 1).toString();
            p.classList.add("popis");
            akce.appendChild(p);


        }

        for (let xd = 0; xd < this.c.spawny.length; xd++) {
            const akce = document.querySelector("#slider" + xd.toString());
            akce.addEventListener("mouseover", () => {
                this.c.spawny[xd].maSeZvyraznit = true;
            });
            akce.addEventListener("mouseout", () => {
                this.c.spawny[xd].maSeZvyraznit = false;
            });
            akce.addEventListener("click", () => {
                this.vycistiSubBoksi();
                this.vytvorSubBoksi(this.c.spawny[xd], xd);
                for (let i = 0; i < this.c.spawny.length; i++) {
                    this.oddelatZvyrazneniSpawnu(i);
                }
                this.c.selectedSpawn = this.c.spawny[xd];
                this.zvyraznitVybranySpawn(xd);
            })
        }
    }

    vytvorSubBoksi(spawn, xd) {
        let max = spawn.trasy.length;
        const parent = document.querySelector("#subkonfigurace");
        this.c.subButtony = [];
        for (let i = 0; i < max; i++) {
            const newBox = document.createElement("div");
            newBox.id = "trasa" + i.toString();
            parent.appendChild(newBox);

            const p = document.createElement("p");
            p.innerHTML = "Trasa " + (i + 1).toString();
            p.classList.add("popis");
            newBox.appendChild(p);

            const button = document.createElement("button");
            button.innerHTML = "Spawni Auto" + (i + 1).toString();
            button.setAttribute("id", "button-" + (i + 1).toString());
            button.setAttribute("onclick", "doprava.pridejAuto(" + xd.toString() + "," + i.toString() + ")");
            newBox.appendChild(button);


            this.c.subButtony = [...this.c.subButtony, button];

            newBox.addEventListener("mouseover", () => {
                spawn.zvyraznitTrasu(i, true);
            });
            newBox.addEventListener("mouseout", () => {
                spawn.zvyraznitTrasu(i, false);
            });
        }

    }

    vycistiSubBoksi() {
        const boxy = document.querySelectorAll("#subkonfigurace > div");
        boxy.forEach(box => {
            box.remove();
        })
    }

    zvyrazniSpawny() {
        this.c.spawny.forEach(spawn => {
            if (spawn.maSeZvyraznit) {
                spawn.zvyraznit();
            }
        })
    }

    zvyraznitVybranySpawn(i) {
        const spawn = document.querySelector("#slider" + i.toString());
        spawn.classList.add("selected");
    }

    oddelatZvyrazneniSpawnu(i) {
        const spawn = document.querySelector("#slider" + i.toString());
        spawn.classList.remove("selected");
    }
}