class Pruh {
    constructor(x, y, xsize, ysize, hlavni) {
        this.start = createVector(x, y);
        this.destination = createVector((x + xsize), (y + ysize));
        this.size = createVector(xsize, ysize);
        this.dir = createVector(xsize, ysize).normalize();
        this.nextPruhy = [];
        this.previousPruhy = []; // setrizene zleva doprava
        this.crossProductToNextPruh;
        this.hlavni = hlavni || 0;
        this.cile = [];
        this.visited = 0;
        this.maSeZvyraznit = false;

        this.prochazejiciPruhy = [];
        this.pruseciky = [];
    }

    show() {
        push();
        if (this.maSeZvyraznit) {
            stroke(0, 255, 0);
            strokeWeight(8);
            line(this.start.x, this.start.y, this.destination.x, this.destination.y);
        }

        fill(0);
        if (this.hlavni >= 1) {
            strokeWeight(4);
        } else {
            strokeWeight(2);
        }
        line(this.start.x, this.start.y, this.destination.x, this.destination.y);
        
        pop();
    }
    
    show2() {
        push();
        if (this.maSeZvyraznit) {
            stroke(0, 255, 0);
            strokeWeight(8);
            line(this.start.x, this.start.y, this.destination.x, this.destination.y);
        }
        pop();
    }

    pretocitPruh() {
        let newStart = this.destination.copy();
        let newDestination = this.start.copy();

        this.start = newStart;
        this.destination = newDestination;
        this.size.mult(-1);
        this.dir.mult(-1);
    }

    getNextPruh(sitPruhu) {
        for (let i = 0; i < sitPruhu.length; i++) {
            if (this.destination.x == sitPruhu[i].start.x && this.destination.y == sitPruhu[i].start.y) {
                this.nextPruhy = [...this.nextPruhy, sitPruhu[i]];
                sitPruhu[i].previousPruhy = [...sitPruhu[i].previousPruhy, this];
            }
        }
    }

    najitCile(arrayCilu) {
        this.visited = 1;
        if (this.nextPruhy.length === 0) {
            arrayCilu.push(this);
        } else {
            this.nextPruhy.forEach(pruh => {
                if (!pruh.visited) {
                    pruh.najitCile(arrayCilu);
                } else {
                    this.visited = 0;
                }
            });
        }
    }

    static najitTrasy(cile) {
        let trasy = [];
        cile.forEach(cil => {
            let trasa = [cil];
            let predchoziPruh = cil.previousPruhy.filter(pruh => pruh.visited === 1);
            while (predchoziPruh.length === 1) {
                trasa = [...trasa, ...predchoziPruh];
                predchoziPruh = predchoziPruh[0].previousPruhy.filter(pruh => pruh.visited === 1);
            }
            trasa = trasa.reverse();
            trasy = [...trasy, trasa];
        });
        return trasy;
    }

    showE() {
        push();
        strokeWeight(1);
        circle(this.start.x, this.start.y, 5);
        line(this.start.x, this.start.y, this.destination.x, this.destination.y);
        circle(this.destination.x, this.destination.y, 5);
        pop();
    }

    setriditPrev() {
        this.previousPruhy.forEach(pruh => {
            // console.log(pruh.start, this.start);
            let temp = pruh.start.copy().sub(this.start);
            let cross = this.size.cross(temp).z;
            // console.log(cross);
            pruh.crossProductToNextPruh = cross;
        });
    }

    kriziSe(pruh) {
        let x1 = this.start.x;
        let y1 = this.start.y;
        let x2 = this.destination.x;
        let y2 = this.destination.y;
        let x3 = pruh.start.x;
        let y3 = pruh.start.y;
        let x4 = pruh.destination.x;
        let y4 = pruh.destination.y;

        if (!this.nextPruhy.includes(pruh) && !this.previousPruhy.includes(pruh)) {
            if(this.protinaSe(x1, y1, x2, y2, x3, y3, x4, y4)) {
                this.prochazejiciPruhy = [...this.prochazejiciPruhy, pruh];
            }
        }
    }
    protinaSe(x1, y1, x2, y2, x3, y3, x4, y4) {
        let t;
        let u;

        // denominator pro T a U je stejny
        let denominatorT = (x1 - x2) * (y3 - y4) - (y1 - y2) * (x3 - x4);

        if (denominatorT != 0) {
            let numeratorT = (x1 - x3) * (y3 - y4) - (y1 - y3) * (x3 - x4);
            t = numeratorT / denominatorT;

            let numeratorU = (x1 - x2) * (y1 - y3) - (y1 - y2) * (x1 - x3);
            u = -numeratorU / denominatorT;
            // console.log({t, u});
        }

        if (t > 0 && t < 1 && u > 0 && u < 1) {
            let pointX = x1 + t * (x2 - x1);
            let pointY = y1 + t * (y2 - y1);

            // if(pointX !== this.start.x && pointX !== this.destination.x && pointY !== this.start.y && pointY !== this.destination.y)
            this.pruseciky = [...this.pruseciky, createVector(pointX, pointY)];
            // push();
            // strokeWeight(5);
            // point(pointX, pointY);
            // pop();

            return true;
        }
        return false;
    }
}