let test;
let cesta;
let doprava;
let kurzor;
let prvky;
let cestaJSON;
let cestyPozadi = [];
let situaceJSON;
let texturyAut = [];
let texturyAutSPrednosti = [];
let texturaSemaforu;
let texturyZnacek = [];
let bg;

function preload() {
    let pathMapy = `nahranecesty/ymapa-${situace.mapa}.json`;
    let data = loadJSON(pathMapy, () => {
        cestaJSON = data;
    }, (err) => {
        window.alert("nepodařilo se načíst mapu");
        console.alert(err);
    })

    let pathCesty = 'grafika/cesty/cesta-';
    for (let i = 0; i < 2; i++) {
        let name = pathCesty + i.toString() + ".png";
        let img = loadImage(name, () => {
            cestyPozadi[i] = img;
        });
    }

    let indexAuto = floor(random(0, 18))
    for (let i = 0; i < situace.auta.length; i++) {
        nacistAuta((indexAuto + 5 * i) % 18).then(arr => {
            texturyAut = [...texturyAut, new Textura(arr)];
        });
    }

    for (let i = 0; i < 1; i++) {
        nacistAutaSPrednosti(i).then(arr => texturyAutSPrednosti = [...texturyAutSPrednosti, new Textura(arr)]);
    }

    nacistZnacky().then(znacky => texturyZnacek = [...znacky]).catch(err => console.error("nepodařilo se načíst dopravní značky", err));
}

function setup() {
    var cnv = createCanvas(800, 600);
    cnv.parent('misto-pro-canvas');
    canvas.onselectstart = function () { return false; }
    frameRate(30);

    rerunSetup();
}

function draw() {
    background(bg);
    doprava.fungovani();
}


function rerunSetup() {
    cesta = new Cesta(cestaJSON, texturaSemaforu, texturyZnacek, cestyPozadi, situace);
    doprava = new Doprava(cesta, texturyAut, texturyAutSPrednosti);
    bg = cesta.vyberTexturuCesty();
}

async function nacistAuta(i) {
    let arr = await Promise.all([
        loadImage(`grafika/auta/a-${i.toString()}.png`, img => img.resize(85, 0)),
        loadImage(`grafika/auta-pravyblinkr/a-${i.toString()}-p.png`, img => img.resize(85, 0)),
        loadImage(`grafika/auta-levyblinkr/a-${i.toString()}-l.png`, img => img.resize(85, 0)),
        loadImage(`grafika/auta-brzda/a-${i.toString()}-b.png`, img => img.resize(85, 0)),
        loadImage(`grafika/auta-pravysbrzdou/a-${i.toString()}-pb.png`, img => img.resize(85, 0)),
        loadImage(`grafika/auta-levysbrzdou/a-${i.toString()}-lb.png`, img => img.resize(85, 0))
    ]);

    return arr;
}

async function nacistAutaSPrednosti(i) {
    let arr = await Promise.all([
        loadImage(`grafika/auta-s-prednosti/ap-${i.toString()}.png`, img => img.resize(85, 0)),
        loadImage(`grafika/auta-s-prednosti-pravyblinkr/ap-${i.toString()}-p.png`, img => img.resize(85, 0)),
        loadImage(`grafika/auta-s-prednosti-levyblinkr/ap-${i.toString()}-l.png`, img => img.resize(85, 0)),
        loadImage(`grafika/auta-s-prednosti-brzda/ap-${i.toString()}-b.png`, img => img.resize(85, 0)),
        loadImage(`grafika/auta-s-prednosti-pravysbrzdou/ap-${i.toString()}-pb.png`, img => img.resize(85, 0)),
        loadImage(`grafika/auta-s-prednosti-levysbrzdou/ap-${i.toString()}-lb.png`, img => img.resize(85, 0)),
        loadImage('grafika/majak.png')
    ]);

    return arr;
}

async function nacistSemafor() {
    let path = "grafika/znacky/semafor-";
    let semafor = await Promise.all([
        loadImage(path + "0.png", img => img.resize(100, 0)),
        loadImage(path + "1.png", img => img.resize(100, 0)),
        loadImage(path + "2.png", img => img.resize(100, 0)),
        loadImage(path + "3.png", img => img.resize(100, 0))
    ]);
    return semafor;
}

async function nacistZnacky() {
    let path = "grafika/znacky/";
    let znacky = await Promise.all([
        loadImage(path + "hlavni.png", img => img.resize(120, 0)), //0
        loadImage(path + "konec_hlavni.png", img => img.resize(100, 0)), //1
        loadImage(path + "krizovatka.png", img => img.resize(100, 0)), //2
        loadImage(path + "prednost.png", img => img.resize(100, 0)), //3
        loadImage(path + "stop.png", img => img.resize(100, 0)), //4
        loadImage(path + "hlavni-t-se.png", img => img.resize(50, 0)), //5
        loadImage(path + "hlavni-t-sw.png", img => img.resize(50, 0)), //6
        loadImage(path + "hlavni-t-we.png", img => img.resize(50, 0)), //7
        loadImage(path + "hlavni-x-ne.png", img => img.resize(50, 0)), //8
        loadImage(path + "hlavni-x-se.png", img => img.resize(50, 0)), //9
        loadImage(path + "hlavni-x-sn.png", img => img.resize(50, 0)), //10
        loadImage(path + "hlavni-x-sw.png", img => img.resize(50, 0)), //11
        loadImage(path + "hlavni-x-we.png", img => img.resize(50, 0)), //12
        loadImage(path + "hlavni-x-wn.png", img => img.resize(50, 0)), //13

        loadImage(path + "prednost-t-se.png", img => img.resize(50, 0)), //14
        loadImage(path + "prednost-t-sw.png", img => img.resize(50, 0)), //15
        loadImage(path + "prednost-t-we.png", img => img.resize(50, 0)), //16
        loadImage(path + "prednost-x-ne.png", img => img.resize(50, 0)), //17
        loadImage(path + "prednost-x-se.png", img => img.resize(50, 0)), //18
        loadImage(path + "prednost-x-sn.png", img => img.resize(50, 0)), //19
        loadImage(path + "prednost-x-sw.png", img => img.resize(50, 0)), //20
        loadImage(path + "prednost-x-we.png", img => img.resize(50, 0)), //21
        loadImage(path + "prednost-x-wn.png", img => img.resize(50, 0)), //22
        loadImage(path + "prednost-t-ne.png", img => img.resize(50, 0)), //23

        loadImage(path + "hlavni-t-sw2.png", img => img.resize(50, 0)), //24
        loadImage(path + "hlavni-t-se2.png", img => img.resize(50, 0)), //25
        loadImage(path + "prednost-t-wn2.png", img => img.resize(50, 0)), //26


    ]);
    return znacky;
}
