class Semafor {
    constructor(x, y, initialState, cervenaDuration, zelenaDuration, startingTime, textura, texturaX, texturaY, texturaAngle) {
        this.pos = createVector(x, y);
        this.state = initialState;
        // 0 - cervena, 1 - cervena + oranzova, 2 - zelena, 3 - oranzova
        this.cervenaDuration = cervenaDuration || 10000;
        this.zelenaDuration = zelenaDuration || this.cervenaDuration;
        this.startingTime = startingTime || 0;
        this.casZastaveni = 0;
        this.zastaveno = false;

        this.textura = textura;
        this.texturaX = texturaX;
        this.texturaY = texturaY;
        this.texturaAngle = texturaAngle || 0;

        this.stav();
    }

    show() {
        if (!this.texturaX) {
            push();

            switch (this.state) {
                case 0:
                    fill(255, 0, 0);
                    circle(this.pos.x, this.pos.y, 20);
                    break;
                case 1:
                    angleMode(RADIANS);
                    fill(255, 0, 0);
                    arc(this.pos.x, this.pos.y, 20, 20, PI, TWO_PI);
                    fill(255, 140, 0);
                    arc(this.pos.x, this.pos.y, 20, 20, 0, PI);
                    break;
                case 2:
                    fill(0, 255, 0);
                    circle(this.pos.x, this.pos.y, 20);
                    break;
                case 3:
                    fill(255, 140, 0);
                    circle(this.pos.x, this.pos.y, 20);
                    break;
            }

            if (this.maSeZvyraznit) {
                circle(this.pos.x, this.pos.y);
            }
            pop();

        }
        else {
            push();
            translate(this.texturaX, this.texturaY);
            angleMode(DEGREES);
            rotate(this.texturaAngle);
            image(this.textura.dostat(this.state), 0, 0);
            angleMode(RADIANS);
            pop();
        }
    }

    async stav() {
        this.casZastaveni = performance.now();
        switch (this.state) {
            case 0:
                await this.timeout(this.cervenaDuration - this.startingTime);
                this.state = 1;
                break;
            case 1:
                await this.timeout(1000 - this.startingTime);
                this.state = 2;
                break;
            case 2:
                await this.timeout(this.zelenaDuration - this.startingTime)
                this.state = 3;
                break;
            case 3:
                await this.timeout(1000 - this.startingTime);
                this.state = 0;
                break;
        }
        this.startingTime = 0;
        if (!this.zastaveno) {
            this.stav();
        }
        else {
            this.state = (this.state + 3) % 4;
        }
    }

    timeout(time) {
        return new Promise(resolve => setTimeout(resolve, time));
    }

    zastavit() {

        this.zastaveno = true;
    };

}